function [cg,ceq]=eqfuns(x)
% VN2FR_LGN code

global K J NX pscale ev0
%  K: # of producers
%  J: # of products for each producer
% NX: # of design variables (including price)
% NZ: # of product attribute
xx=reshape(x,[(1+NX+1+2*NX),K])'; % w x1 x2 mr lmu_x1 lmu_x2 umu_x1 umu_x2
xw=xx(:,1); x1=xx(:,2); x2=xx(:,3); xm=xx(:,4);
lmux=xx(:,1+NX+2:1+NX+1+NX); % size [K,NX]
umux=xx(:,1+NX+1+NX+1:1+NX+1+2*NX); % size [K,NX]
 mux=reshape([lmux,umux]',[K*2*NX,1]); % size[K*2*NX,1]

%% to get L
z=getz(xx);
v=getv(z);
ev=exp(v);
evsum=sum(ev,1)+ev0; % ev0 = exp(utility of outside good)
L=ev./repmat(evsum,[K,1,1]);

%% get eq funs
dpidw=getdpidw(xx,L);
dpidx=getdpidx(xx,z,L); % size [K,NX]
dpidm=getdpidm(xx,L);

%% Lagrangian for constraint handling (KKT) part 1: dL/dx=0
gradg=[-1,0;0,-1;1,0;0,1];
for k=1:K
    mugradg(k,:)=mux((k-1)*2*NX+1:k*2*NX)'*gradg;
end
% grad (details in notebook)
dLdx=dpidx-mugradg;  % size [K,NX]
VdLdx=reshape(dLdx',[K*NX,1]); % size [K*NX,1]

%% Lagrangian contraint handling (KKT) part 2: mu*g=0
lg=lmux.*[0.5-x1,0.5-x2];
ug=umux.*[x1-3.0,x2-1.5];
 g=[lg,ug]';
mu_g=sum(reshape(mux,[2*NX,K]).*g,1)'; % FOC: mu_g must equal 0

%% ceq = FOC functions
ceq=[dpidw;
     VdLdx;
     dpidm;
     mu_g];

cg=[]; % dummy cg