function dvdx=getdvdx(xx,z)

global K J T NDRAW beta
% beta size: [1,NZ,NDRAW]
% z size: [K,NZ]
zz=repmat(z,[1,1,NDRAW]); % zz size: [K*T,NZ,NDRAW]
bb=repmat(beta,[K*T,1,1]);  % bb size: [K*T,NZ,NDRAW]

% calculate dvdz
dvdp =bb(:,1,:);
dvdz1=-100.*bb(:,2,:)./zz(:,2,:).^2;
dvdz2= -60.*bb(:,3,:)./zz(:,3,:).^2;
dvdz=[dvdp,dvdz1,dvdz2]; % size: [K,NZ,NDRAW]

%% calculate dzdx analytically - call getdzdx
dzdx=getdzdx(xx); % size: [K*T,NZ,NX]
for kt=1:K*T
    for r=1:NDRAW
     dvdx(kt,:,r)=dvdz(kt,2:3,r)*squeeze(dzdx(kt,:,:)); % 2:3 is z1&z2
    end
end
% size of dvdx: [K,NX,NDRAW]
