function dvdx=getdvdx(xx,z)

global K J T NDRAW beta
% beta size: [1,NZ,NDRAW]
% z size: [K,NZ]
zz=repmat(z,[1,1,NDRAW]); % zz size: [K*T,NZ,NDRAW]
bb=repmat(beta,[K*T,1,1]);  % bb size: [K*T,NZ,NDRAW]

% calculate dvdz
dvdp =bb(:,1,:);
dvdz1=-100.*bb(:,2,:)./zz(:,2,:).^2;
dvdz2= -60.*bb(:,3,:)./zz(:,3,:).^2;
dvdz=[dvdp,dvdz1,dvdz2]; % size: [K,NZ,NDRAW]

%% calculate dzdx analytically - call getdzdx
dzdx=getdzdx(xx); % size: [K*T,NZ,NX]
for kt=1:K*T
    for r=1:NDRAW
     dvdx(kt,:,r)=dvdz(kt,2:3,r)*squeeze(dzdx(kt,:,:)); % 2:3 is z1&z2
    end
end
% size of dvdx: [K,NX,NDRAW]

%% calculate dzdx - central difference method (old section for spline)
%dxu=zeros(K,NX,NX);  dxl=dxu;
%for i=1:NX
%    dxu(:,i,i)= ones(K,1)*delta;
%    dxl(:,i,i)=-ones(K,1)*delta;
%end
%xu=dxu+repmat(xx,[1,1,NX]);
%xl=dxl+repmat(xx,[1,1,NX]);
%zu=getz(xu);
%zl=getz(xl);
%dzdx=(zu-zl)/2/delta; % size: [K,NZ,NX]

%% out-of-date section - calcualte dvdx directly (incorrect)
%dx=repmat(eye(NX-1),[K,1,2]); % NZ-1: not including price
%dx(:,:,1)=dx(:,:,1)*delta;
%dx(:,:,2)=dx(:,:,2)*-delta;
%cx=reshape((repmat(reshape(xx(:,2:NX),[1,NX-1,K]),[NX-1,1,1])),[K*(NX-1),NX-1]);
%uxlx=repmat(cx,[1,1,2])+dx;  % ux=(:,:,1), lx=(:,:,2)
%pp=reshape(repmat(xx(:,1)',[NX-1,1]),[K*(NX-1),1]);
%XX=[repmat(pp,[1,1,2]),uxlx];
%LZ=getz(XX(:,:,1)); UZ=getz(XX(:,:,2));
%LV=getv(LZ);  UV=getv(UZ);
%vdvdx=(UV-LV)/2/delta;
%dvdx=reshape(vdvdx,[NX-1,K,NDRAW]); 