% SECTION II. Verify Nash conditions for all FOC solutions
clear focsols
load solfile
NSOL=size(focsols,2);  % get # of FOC solutions

xwxlb = [ 0, 0,1.0,0.8];
xwxub = [10,10,3.0,1.3];
xmlb=[ 0, 0];
xmub=[10,10];
passncindex=[];
options=optimset('Display','off','LargeScale','off','Algorithm','active-set');

for solindex=1:NSOL

    xx0=focsols(solindex).xx; % size [K,T,4]
    FOCprofitM=focsols(solindex).profitMFGR;
    FOCprofitR=focsols(solindex).profitMCR;
    failcountM=0;
    k=1;
    while(k<=K)
        
        % part.1 check Manufatcurer profit
        xwx0=[1.3,1.3,1.5,1.1]; % xw_t1 xw_t2 x1 x2
        [xwxsol,nfvalM,exitflag] = fmincon(@objprofitM,xwx0,...
          [],[],[],[],xwxlb,xwxub,[],options,xx0,k);
        %disp([round(-nfvalM),round(FOCprofitM(k))])
        if round(-nfvalM) > round(FOCprofitM(k)),
            failcountM=failcountM+1;
        end % end of if loop
        if failcountM>0,
            disp(sprintf('Nash criteria check for sol#%d manufacturer k%d failed',solindex,k));
            k=K+100; % set the k>K to break the while loop
        else
            disp(sprintf('Nash criteria check for sol#%d manufacturer k%d passed',solindex,k));
            k=k+1; % continue to check next manufacturer
        end

    end % end of k while loop

    % part 2. if MFGR check passed, then continue to check MCR profit
    if failcountM==0
        t=1;
        failcountR=0;
        while(t<=T)
            xm0=[0.5,0.5]; % xm_t1 xm_t2
            [xwxsol,nfvalR,exitflag] = fmincon(@objprofitMCR,xm0,...
              [],[],[],[],xmlb,xmub,[],options,xx0,t);
            %disp([round(-nfvalR),round(FOCprofitR(t))])
            if round(-nfvalR) > round(FOCprofitR(t)),
                failcountR=failcountR+1;
            end % end of if loop
            if failcountR>0,
            disp(sprintf('Nash criteria check for sol#%d retailer t%d failed',solindex,t));
                t=T+100; % set the k>K to break the while loop
            else
            disp(sprintf('Nash criteria check for sol#%d retailer t%d passed',solindex,t));
                t=t+1; % continue to check next manufacturer
            end
            
        end % end of t's while loop
        
        % if all passed, store the set of solution
        if failcountM==0 && failcountR==0
            passncindex=[passncindex;solindex];
        end
        
    end % end of k's while loop
        
end % end of big solindex loop

disp(sprintf('Total # of solutions passed NC check = %d',passncindex'));