function [profitM,pr,cv,profitMP]=estprofitM(xx,z)
% For the MCR case, xx has 4 dimensions
% In MCR, each manufacturer has mutiple products to deliver to different
%  common retailers

% xx size: [K,J,T,NX+2]
global beta K J T B4 B5 enginebaseSI pscale ev0
global costInvest costBody mktSize NDRAW
xw=xx(:,:,:,1); % size [K,J,T,1]
x1=xx(:,:,:,2);
x2=xx(:,:,:,3);
xm=xx(:,:,:,4);
w=pscale.*xw; mr=pscale.*xm; p=w+mr; pw=enginebaseSI.*x1;

costEngine=B4*exp(B5*pw);
cv=costEngine+costBody;
% z: size [K,NZ]
zz=repmat(z,[1,1,1,1,NDRAW]); % size [K,J,T,NZ,NDRAW]
b=shiftdim(beta,-2); % size [1,1,1,NZ,NDRAW]
bb=repmat(b,[K,J,T,1,1]);  % size [K,J,T,NZ,NDRAW]
vv=bb(:,:,:,1,:).*zz(:,:,:,1,:)+100*bb(:,:,:,2,:)./zz(:,:,:,2,:)+...
    60*bb(:,:,:,3,:)./zz(:,:,:,3,:);
ev=exp(vv);
evsum=sum(sum(sum(ev,3),2),1)+ev0;  % ev0 = exp(utility of outside good)
% for each manufacturer has one product only
% for multiple porduct - need sum twice: sum(sum(ev,2),1)
L=ev./repmat(evsum,[K,J,T,1]); % also for each manufacturer has one product only
pr=sum(L,5)./NDRAW; % average over simulation size: [K,J,T]
qty=pr*mktSize;

% *** Manufacturer's profit is from all his product selling through
%     multiple common retailers
% profitMP = manufacturer profit of each product
profitMP=qty.*(w-cv)-costInvest; % size [K,J,T]

% sum up profitMP from different common retailers
profitM=sum(profitMP,3); % size [K,J]